diff --git a/src/main/java/net/minecraft/client/render/entity/SpiderRenderer.java b/src/main/java/net/minecraft/client/render/entity/SpiderRenderer.java
index 67517ddd6..a00bd7d1b 100644
--- a/src/main/java/net/minecraft/client/render/entity/SpiderRenderer.java
+++ b/src/main/java/net/minecraft/client/render/entity/SpiderRenderer.java
@@ -1,6 +1,7 @@
 package net.minecraft.client.render.entity;
 
 import net.minecraft.client.Minecraft;
+import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.model.ModelSpider;
 import net.minecraft.core.Global;
 import net.minecraft.core.entity.monster.EntitySpider;
@@ -30,7 +31,9 @@ public class SpiderRenderer extends LivingRenderer<EntitySpider>
             boolean useVariants = Minecraft.getMinecraft(this).gameSettings.mobVariants.value;
             loadTexture("/assets/minecraft/textures/entity/spider/eyes/" + (useVariants ? spider.getSkinVariant() : 0) + ".png");
             float brightness = spider.getBrightness(1.0f);
-            if (Global.accessor.isFullbrightEnabled()) brightness = 1.0f;
+            if(LightmapHelper.isLightmapEnabled()) {
+                LightmapHelper.setLightmapCoord(LightmapHelper.getLightmapCoord(15, 15));
+            }
             float f1 = (1.0F - brightness) * 0.5F;
             GL11.glEnable(3042 /*GL_BLEND*/);
             GL11.glDisable(3008 /*GL_ALPHA_TEST*/);
@@ -49,8 +52,7 @@ public class SpiderRenderer extends LivingRenderer<EntitySpider>
     }
 
     @Override
-    protected boolean shouldRenderPass(EntitySpider entity, int renderPass, float partialTick)
-    {
+    protected boolean shouldRenderPass(EntitySpider entity, int renderPass, float partialTick) {
         return setSpiderEyeBrightness(entity, renderPass, partialTick);
     }
 }
diff --git a/src/main/java/net/minecraft/client/render/entity/TNTRenderer.java b/src/main/java/net/minecraft/client/render/entity/TNTRenderer.java
index 2c2184232..4503ceba7 100644
--- a/src/main/java/net/minecraft/client/render/entity/TNTRenderer.java
+++ b/src/main/java/net/minecraft/client/render/entity/TNTRenderer.java
@@ -1,6 +1,5 @@
 package net.minecraft.client.render.entity;
 
-import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.RenderBlocks;
 import net.minecraft.client.render.block.model.BlockModel;
 import net.minecraft.client.render.block.model.BlockModelDispatcher;
@@ -51,7 +50,7 @@ public class TNTRenderer extends EntityRenderer<EntityTNT>
         float brightness = tnt.getBrightness(f1);
         if (Global.accessor.isFullbrightEnabled()) brightness = 1.0f;
         BlockModel<Block> model = BlockModelDispatcher.getInstance().getDispatch(Block.tnt);
-        model.renderBlockOnInventory(tessellator, 0, brightness);
+        model.renderBlockOnInventory(tessellator, 0, brightness, null);
         if((tnt.fuse / 5) % 2 == 0)
         {
             GL11.glDisable(3553 /*GL_TEXTURE_2D*/);
@@ -59,7 +58,7 @@ public class TNTRenderer extends EntityRenderer<EntityTNT>
             GL11.glEnable(3042 /*GL_BLEND*/);
             GL11.glBlendFunc(770, 772);
             GL11.glColor4f(1.0F, 1.0F, 1.0F, f3);
-            model.renderBlockOnInventory(tessellator, 0, 1.0F);
+            model.renderBlockOnInventory(tessellator, 0, 1.0F, null);
             GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
             GL11.glDisable(3042 /*GL_BLEND*/);
             GL11.glEnable(2896 /*GL_LIGHTING*/);
diff --git a/src/main/java/net/minecraft/client/render/item/model/ItemModelBlock.java b/src/main/java/net/minecraft/client/render/item/model/ItemModelBlock.java
index 0c15f018a..dd0d26edd 100644
--- a/src/main/java/net/minecraft/client/render/item/model/ItemModelBlock.java
+++ b/src/main/java/net/minecraft/client/render/item/model/ItemModelBlock.java
@@ -81,7 +81,7 @@ public class ItemModelBlock extends ItemModelStandard {
             GL11.glEnable(GL_BLEND);
             GL11.glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
             TextureRegistry.blockAtlas.bindTexture();
-            BlockModelDispatcher.getInstance().getDispatch(Block.blocksList[itemstack.itemID]).renderBlockOnInventory(tessellator, itemstack.getMetadata(), brightness);
+            BlockModelDispatcher.getInstance().getDispatch(Block.blocksList[itemstack.itemID]).renderBlockOnInventory(tessellator, itemstack.getMetadata(), brightness, null);
             GL11.glDisable(GL_BLEND);
         } else {
             super.renderItem(tessellator, renderer, itemstack, entity, brightness, handheldTransform);
@@ -126,7 +126,7 @@ public class ItemModelBlock extends ItemModelStandard {
             }
             GL11.glRotatef(-90F, 0.0F, 1.0F, 0.0F);
             BlockModel.renderBlocks.useInventoryTint = useColor;
-            BlockModelDispatcher.getInstance().getDispatch(Block.blocksList[itemStack.itemID]).renderBlockOnInventory(tessellator, itemStack.getMetadata(), brightness, alpha);
+            BlockModelDispatcher.getInstance().getDispatch(Block.blocksList[itemStack.itemID]).renderBlockOnInventory(tessellator, itemStack.getMetadata(), brightness, alpha, null);
             BlockModel.renderBlocks.useInventoryTint = true;
             GL11.glPopMatrix();
         } else {
@@ -158,7 +158,7 @@ public class ItemModelBlock extends ItemModelStandard {
                 if (Global.accessor.isFullbrightEnabled() || itemfullBright) {
                 	brightness = 1.0f;
                 }
-                blockModel.renderBlockOnInventory(tessellator, itemstack.getMetadata(), brightness);
+                blockModel.renderBlockOnInventory(tessellator, itemstack.getMetadata(), brightness, null);
                 GL11.glPopMatrix();
             }
         } else {
@@ -186,7 +186,7 @@ public class ItemModelBlock extends ItemModelStandard {
             }
             GL11.glRotatef(90F, 0.0F, 1.0F, 0.0F);
             BlockModel.renderBlocks.useInventoryTint = useColor;
-            BlockModelDispatcher.getInstance().getDispatch(Block.blocksList[itemStack.itemID]).renderBlockOnInventory(tessellator, itemStack.getMetadata(), brightness, alpha);
+            BlockModelDispatcher.getInstance().getDispatch(Block.blocksList[itemStack.itemID]).renderBlockOnInventory(tessellator, itemStack.getMetadata(), brightness, alpha, null);
             BlockModel.renderBlocks.useInventoryTint = true;
         } else {
             super.renderItemInWorld(tessellator, entity, itemStack, brightness, alpha, worldTransform);
diff --git a/src/main/java/net/minecraft/client/render/item/model/ItemModelStandard.java b/src/main/java/net/minecraft/client/render/item/model/ItemModelStandard.java
index fb521806d..b14ac8af0 100644
--- a/src/main/java/net/minecraft/client/render/item/model/ItemModelStandard.java
+++ b/src/main/java/net/minecraft/client/render/item/model/ItemModelStandard.java
@@ -118,7 +118,7 @@ public class ItemModelStandard extends ItemModel{
         	if(LightmapHelper.isLightmapEnabled()) {
             	int lightmapCoord = entity.getLightmapCoord(1.0f);
             	if(itemfullBright) {
-            		lightmapCoord = LightmapHelper.setBlocklightValue(lightmapCoord, 15);
+            		lightmapCoord = LightmapHelper.getLightmapCoord(15, 15);
             	}
             	LightmapHelper.setLightmapCoord(lightmapCoord);	
         	}
diff --git a/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererFlowerJar.java b/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererFlowerJar.java
index cc2457508..46cf8a00b 100644
--- a/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererFlowerJar.java
+++ b/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererFlowerJar.java
@@ -1,6 +1,7 @@
 package net.minecraft.client.render.tileentity;
 
 import net.minecraft.client.Minecraft;
+import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.RenderBlocks;
 import net.minecraft.client.render.block.model.BlockModel;
 import net.minecraft.client.render.block.model.BlockModelDispatcher;
@@ -9,6 +10,7 @@ import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.Global;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.entity.TileEntityFlowerJar;
+import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.world.World;
 import org.lwjgl.opengl.GL11;
 
@@ -32,7 +34,15 @@ public class TileEntityRendererFlowerJar extends TileEntityRenderer<TileEntityFl
             float lightLevel = Minecraft.getMinecraft(this).theWorld.getLightBrightness(tileEntity.x, tileEntity.y, tileEntity.z);
             if (Global.accessor.isFullbrightEnabled()) lightLevel = 1.0f;
             BlockModel.setRenderBlocks(renderBlocks);
-            BlockModelDispatcher.getInstance().getDispatch(block).renderBlockOnInventory(tessellator, 0, lightLevel);
+            Integer lmc = null;
+            if (LightmapHelper.isLightmapEnabled()){
+                if (Global.accessor.isFullbrightEnabled()){
+                    lmc = LightmapHelper.getOverbrightLightmapCoord(tileEntity.worldObj.getSavedLightValue(LightLayer.Sky, tileEntity.x, tileEntity.y, tileEntity.z));
+                } else {
+                    lmc = tileEntity.worldObj.getLightmapCoord(tileEntity.x, tileEntity.y, tileEntity.z, 0);
+                }
+            }
+            BlockModelDispatcher.getInstance().getDispatch(block).renderBlockOnInventory(tessellator, 0, lightLevel, lmc);
         }
         GL11.glPopMatrix();
     }
diff --git a/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMesh.java b/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMesh.java
index 96fd83a11..f7c3f4c8a 100644
--- a/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMesh.java
+++ b/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMesh.java
@@ -35,7 +35,9 @@ public class TileEntityRendererMesh extends TileEntityRenderer<TileEntityMeshGol
         if (Global.accessor.isFullbrightEnabled()) lightLevel = 1.0f;
         BlockModel.setRenderBlocks(EntityRenderDispatcher.instance.itemRenderer.renderBlocksInstance);
         GL11.glEnable(32826 /*GL_RESCALE_NORMAL_EXT*/);
+        GL11.glEnable(GL11.GL_BLEND);
         ItemModelDispatcher.getInstance().getDispatch(tileEntity.filterItem).renderAsItemEntity(Tessellator.instance, renderEntity, tileEntity.worldObj.rand, tileEntity.filterItem, 1, f3, lightLevel, renderPartialTicks);
+        GL11.glDisable(GL11.GL_BLEND);
         GL11.glDisable(32826 /*GL_RESCALE_NORMAL_EXT*/);
         GL11.glPopMatrix();
         
diff --git a/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMobSpawner.java b/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMobSpawner.java
index bacf15a44..b49ca0664 100644
--- a/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMobSpawner.java
+++ b/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMobSpawner.java
@@ -4,6 +4,7 @@ import java.util.HashMap;
 import java.util.Map;
 
 import net.minecraft.client.render.EntityRenderDispatcher;
+import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.entity.TileEntityMobSpawner;
 import net.minecraft.core.entity.Entity;
@@ -48,7 +49,8 @@ public class TileEntityRendererMobSpawner extends TileEntityRenderer<TileEntityM
             GL11.glRotatef(-30F, 1.0F, 0.0F, 0.0F);
             GL11.glTranslatef(0.0F, -0.4F, 0.0F);
             GL11.glScalef(f1, f1, f1);
-            entity.moveTo(x, y, z, 0.0F, 0.0F);
+//            System.out.printf("X: %f, Y: %f, Z: %f\n", x, y, z);
+            entity.moveTo(mobSpawner.x, mobSpawner.y, mobSpawner.z, 0.0F, 0.0F);
             EntityRenderDispatcher.instance.renderEntityWithPosYaw(tessellator, entity, 0.0D, 0.0D, 0.0D, 0.0F, partialTick);
         }
         GL11.glPopMatrix();
diff --git a/src/main/java/net/minecraft/client/util/debug/DebugRender.java b/src/main/java/net/minecraft/client/util/debug/DebugRender.java
index 2151a5486..ada5836f7 100644
--- a/src/main/java/net/minecraft/client/util/debug/DebugRender.java
+++ b/src/main/java/net/minecraft/client/util/debug/DebugRender.java
@@ -2,6 +2,8 @@ package net.minecraft.client.util.debug;
 
 import static org.lwjgl.opengl.GL11.*;
 
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.render.window.GameWindowLWJGL2;
 import org.lwjgl.input.Keyboard;
 import org.lwjgl.opengl.Display;
 
@@ -13,8 +15,8 @@ import net.minecraft.core.util.helper.MathHelper;
 public class DebugRender {
 	
 	private static Profiler selectedProfiler = Debug.baseProfiler;
-	private static long[] frametimes = new long[512];
-	private static long[] baseframetimes = new long[512];
+	private static final long[] frametimes = new long[512];
+	private static final long[] baseframetimes = new long[512];
 	private static int pos = 0;
 	private static int scale = 200000;
 	private static int selection = 0;
@@ -158,6 +160,8 @@ public class DebugRender {
 		drawRectangle(tessellator, x, y - h2, frametimes.length, h2);
 		drawRectangle(tessellator, x, y - h1, frametimes.length, h1);
 		tessellator.setColorOpaque_I(0xFFFFFF);
+
+
 		
 		for(int i=0; i < frametimes.length; i++) {
 			float brightness = ((i - pos) & (frametimes.length - 1)) / (float) frametimes.length;
@@ -168,7 +172,28 @@ public class DebugRender {
 			int time = (int) (frametimes[i] / scale);
 			drawRectangle(tessellator, x + i, y - time, 1, time);
 		}
-		
+
+		final int tickLagHeight = (int) ((1000/20d * 1000 * 1000)/(double) scale);
+
+		tessellator.setColorOpaque_I(0xFF0000);
+		drawRectangle(tessellator, x, y - tickLagHeight, frametimes.length, 1);
+
+		Minecraft mc = Minecraft.getMinecraft(Minecraft.class);
+		if (mc.gameSettings.customFpsLimit.value > 0 || mc.gameSettings.enableVsync.value){
+			tessellator.setColorOpaque_I(0x00FF00);
+			int fps = 0;
+			if (mc.gameSettings.enableVsync.value){
+				if(mc.gameWindow instanceof GameWindowLWJGL2){
+					fps = ((GameWindowLWJGL2) mc.gameWindow).defaultDisplayMode.getFrequency(); // Cap fps when minimized
+				}
+			} else {
+				fps = mc.gameSettings.customFpsLimit.value;
+			}
+
+			int frameLagHeight = (int) ((1000d/fps * 1000 * 1000)/scale);
+			drawRectangle(tessellator, x, y - frameLagHeight, frametimes.length, 1);
+		}
+
 		tessellator.draw();
 	}
 	
diff --git a/src/main/java/net/minecraft/client/world/WorldBlockPositionType.java b/src/main/java/net/minecraft/client/world/WorldBlockPositionType.java
index 48e80703a..dabe74d91 100644
--- a/src/main/java/net/minecraft/client/world/WorldBlockPositionType.java
+++ b/src/main/java/net/minecraft/client/world/WorldBlockPositionType.java
@@ -4,28 +4,23 @@ package net.minecraft.client.world;
 // Referenced classes of package net.minecraft.src:
 //            WorldClient
 
-import net.minecraft.client.world.WorldClient;
-
 class WorldBlockPositionType
 {
+    int x;
+    int y;
+    int z;
+    int delayTicks;
+    int blockId;
+    int metadata;
+    final WorldClient worldClient; /* synthetic field */
 
-    public WorldBlockPositionType(WorldClient worldclient, int i, int j, int k, int l, int i1)
-    {
-//        super();
-        field_1203_g = worldclient;
-        field_1202_a = i;
-        field_1201_b = j;
-        field_1207_c = k;
-        field_1206_d = 80;
-        field_1205_e = l;
-        field_1204_f = i1;
+    public WorldBlockPositionType(WorldClient worldclient, int x, int y, int z, int blockId, int metadata) {
+        this.worldClient = worldclient;
+        this.x = x;
+        this.y = y;
+        this.z = z;
+        this.delayTicks = 80;
+        this.blockId = blockId;
+        this.metadata = metadata;
     }
-
-    int field_1202_a;
-    int field_1201_b;
-    int field_1207_c;
-    int field_1206_d;
-    int field_1205_e;
-    int field_1204_f;
-    final WorldClient field_1203_g; /* synthetic field */
 }
diff --git a/src/main/java/net/minecraft/client/world/WorldClient.java b/src/main/java/net/minecraft/client/world/WorldClient.java
index d79651dad..ca6cd0d75 100644
--- a/src/main/java/net/minecraft/client/world/WorldClient.java
+++ b/src/main/java/net/minecraft/client/world/WorldClient.java
@@ -1,9 +1,5 @@
 package net.minecraft.client.world;
 
-import java.util.HashSet;
-import java.util.LinkedList;
-import java.util.Set;
-
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.net.handler.NetClientHandler;
 import net.minecraft.client.world.chunk.provider.ChunkProviderClient;
@@ -17,23 +13,32 @@ import net.minecraft.core.world.chunk.provider.IChunkProvider;
 import net.minecraft.core.world.pathfinder.IdHashMap;
 import net.minecraft.core.world.save.SaveHandlerClientMP;
 
+import java.util.HashSet;
+import java.util.LinkedList;
+import java.util.Set;
+
 // Referenced classes of package net.minecraft.src:
 //            World, SaveHandlerMP, WorldProvider, MCHash, 
 //            ChunkCoordinates, NetClientHandler, IWorldAccess, Entity, 
 //            WorldBlockPositionType, ChunkProviderClient, Packet255KickDisconnect, WorldInfo, 
 //            IChunkProvider
 
-public class WorldClient extends World
-{
-
+public class WorldClient extends World {
+    private final Minecraft mc;
+    private final LinkedList<WorldBlockPositionType> positionTypesList;
+    private final NetClientHandler sendQueue;
+    private ChunkProviderClient field_20915_C;
+    private final IdHashMap<Entity> entityMap;
+    private final Set<Entity> field_20914_E;
+    private final Set<Entity> field_1053_F;
     public WorldClient(Minecraft minecraft, NetClientHandler netclienthandler, long seed, int dimensionId, int worldTypeId)
     {
         super(new SaveHandlerClientMP(), "MpServer", Dimension.getDimensionList().get(dimensionId), Registries.WORLD_TYPES.getItemByNumericId(worldTypeId), seed);
         this.mc = minecraft;
-        field_1057_z = new LinkedList();
-        entityMap = new IdHashMap();
-        field_20914_E = new HashSet();
-        field_1053_F = new HashSet();
+        positionTypesList = new LinkedList<>();
+        entityMap = new IdHashMap<>();
+        field_20914_E = new HashSet<>();
+        field_1053_F = new HashSet<>();
         sendQueue = netclienthandler;
         setSpawnPoint(new ChunkCoordinates(8, 64, 8));
         savedDataStorage = netclienthandler.savedDataStorage;
@@ -44,7 +49,7 @@ public class WorldClient extends World
     {
         for(int k = 0; k < 10 && !field_1053_F.isEmpty(); k++)
         {
-            Entity entity = (Entity)field_1053_F.iterator().next();
+            Entity entity = field_1053_F.iterator().next();
             if(!loadedEntityList.contains(entity))
             {
                 entityJoinedWorld(entity);
@@ -52,14 +57,14 @@ public class WorldClient extends World
         }
 
         processPackets();
-        for(int l = 0; l < field_1057_z.size(); l++)
+        for(int l = 0; l < positionTypesList.size(); l++)
         {
-            WorldBlockPositionType worldblockpositiontype = (WorldBlockPositionType)field_1057_z.get(l);
-            if(--worldblockpositiontype.field_1206_d == 0)
+            WorldBlockPositionType worldblockpositiontype = positionTypesList.get(l);
+            if(--worldblockpositiontype.delayTicks == 0)
             {
-                super.setBlockAndMetadata(worldblockpositiontype.field_1202_a, worldblockpositiontype.field_1201_b, worldblockpositiontype.field_1207_c, worldblockpositiontype.field_1205_e, worldblockpositiontype.field_1204_f);
-                super.markBlockNeedsUpdate(worldblockpositiontype.field_1202_a, worldblockpositiontype.field_1201_b, worldblockpositiontype.field_1207_c);
-                field_1057_z.remove(l--);
+                super.setBlockAndMetadata(worldblockpositiontype.x, worldblockpositiontype.y, worldblockpositiontype.z, worldblockpositiontype.blockId, worldblockpositiontype.metadata);
+                super.markBlockNeedsUpdate(worldblockpositiontype.x, worldblockpositiontype.y, worldblockpositiontype.z);
+                positionTypesList.remove(l--);
             }
         }
 		updateSeasonAndLight();
@@ -71,12 +76,12 @@ public class WorldClient extends World
 
     public void func_711_c(int i, int j, int k, int l, int i1, int j1)
     {
-        for(int k1 = 0; k1 < field_1057_z.size(); k1++)
+        for(int k1 = 0; k1 < positionTypesList.size(); k1++)
         {
-            WorldBlockPositionType worldblockpositiontype = (WorldBlockPositionType)field_1057_z.get(k1);
-            if(worldblockpositiontype.field_1202_a >= i && worldblockpositiontype.field_1201_b >= j && worldblockpositiontype.field_1207_c >= k && worldblockpositiontype.field_1202_a <= l && worldblockpositiontype.field_1201_b <= i1 && worldblockpositiontype.field_1207_c <= j1)
+            WorldBlockPositionType worldblockpositiontype = positionTypesList.get(k1);
+            if(worldblockpositiontype.x >= i && worldblockpositiontype.y >= j && worldblockpositiontype.z >= k && worldblockpositiontype.x <= l && worldblockpositiontype.y <= i1 && worldblockpositiontype.z <= j1)
             {
-                field_1057_z.remove(k1--);
+                positionTypesList.remove(k1--);
             }
         }
 
@@ -149,10 +154,7 @@ public class WorldClient extends World
 	protected void obtainEntitySkin(Entity entity)
     {
         super.obtainEntitySkin(entity);
-        if(field_1053_F.contains(entity))
-        {
-            field_1053_F.remove(entity);
-        }
+        field_1053_F.remove(entity);
     }
 
     @Override
@@ -183,12 +185,12 @@ public class WorldClient extends World
 
     public Entity getEntityFromId(int i)
     {
-        return (Entity) entityMap.get(i);
+        return entityMap.get(i);
     }
 
     public Entity removeEntityFromWorld(int i)
     {
-        Entity entity = (Entity) entityMap.remove(i);
+        Entity entity = entityMap.remove(i);
         if(entity != null)
         {
             field_20914_E.remove(entity);
@@ -204,7 +206,7 @@ public class WorldClient extends World
         int j1 = getBlockMetadata(i, j, k);
         if(super.setBlockMetadata(i, j, k, l))
         {
-            field_1057_z.add(new WorldBlockPositionType(this, i, j, k, i1, j1));
+            positionTypesList.add(new WorldBlockPositionType(this, i, j, k, i1, j1));
             return true;
         } else
         {
@@ -219,7 +221,7 @@ public class WorldClient extends World
         int k1 = getBlockMetadata(i, j, k);
         if(super.setBlockAndMetadata(i, j, k, l, i1))
         {
-            field_1057_z.add(new WorldBlockPositionType(this, i, j, k, j1, k1));
+            positionTypesList.add(new WorldBlockPositionType(this, i, j, k, j1, k1));
             return true;
         } else
         {
@@ -228,13 +230,13 @@ public class WorldClient extends World
     }
 
     @Override
-	public boolean setBlock(int i, int j, int k, int l)
+	public boolean setBlock(int x, int y, int z, int id)
     {
-        int i1 = getBlockId(i, j, k);
-        int j1 = getBlockMetadata(i, j, k);
-        if(super.setBlock(i, j, k, l))
+        int blockId = getBlockId(x, y, z);
+        int meta = getBlockMetadata(x, y, z);
+        if(super.setBlock(x, y, z, id))
         {
-            field_1057_z.add(new WorldBlockPositionType(this, i, j, k, i1, j1));
+            positionTypesList.add(new WorldBlockPositionType(this, x, y, z, blockId, meta));
             return true;
         } else
         {
@@ -242,12 +244,12 @@ public class WorldClient extends World
         }
     }
 
-    public boolean func_714_c(int i, int j, int k, int l, int i1)
+    public boolean blockChange(int x, int y, int z, int id, int meta)
     {
-        func_711_c(i, j, k, i, j, k);
-        if(super.setBlockAndMetadata(i, j, k, l, i1))
+        func_711_c(x, y, z, x, y, z);
+        if(super.setBlockAndMetadata(x, y, z, id, meta))
         {
-            notifyBlockChange(i, j, k, l);
+            notifyBlockChange(x, y, z, id);
             return true;
         } else
         {
@@ -261,11 +263,8 @@ public class WorldClient extends World
         sendQueue.func_28117_a(new Packet255KickDisconnect("Quitting"));
     }
 
-    private Minecraft mc;
-    private LinkedList field_1057_z;
-    private NetClientHandler sendQueue;
-    private ChunkProviderClient field_20915_C;
-    private IdHashMap entityMap;
-    private Set field_20914_E;
-    private Set field_1053_F;
+    @Override
+    public void sendGlobalMessage(String message){
+
+    }
 }
diff --git a/src/main/java/net/minecraft/client/world/chunk/provider/ChunkProviderClient.java b/src/main/java/net/minecraft/client/world/chunk/provider/ChunkProviderClient.java
index 6cc5c89c8..86eaa9f7a 100644
--- a/src/main/java/net/minecraft/client/world/chunk/provider/ChunkProviderClient.java
+++ b/src/main/java/net/minecraft/client/world/chunk/provider/ChunkProviderClient.java
@@ -19,8 +19,8 @@ public class ChunkProviderClient
 
     public ChunkProviderClient(World world)
     {
-        chunkMapping = new HashMap();
-        field_889_c = new ArrayList();
+        chunkMapping = new HashMap<>();
+        chunks = new ArrayList<>();
         blankChunk = new EmptyChunk(world, 0, 0);
         worldObj = world;
     }
@@ -28,14 +28,17 @@ public class ChunkProviderClient
     @Override
     public boolean isChunkLoaded(int chunkX, int chunkZ)
     {
-        if(this != null)
+        return true;
+
+        // Previous code always returned true, possibly was a bug?
+        /*if(this != null)
         {
             return true;
         } else
         {
             ChunkCoordinate chunkcoordintpair = new ChunkCoordinate(chunkX, chunkZ);
             return chunkMapping.containsKey(chunkcoordintpair);
-        }
+        }*/
     }
 
     @Override
@@ -51,7 +54,7 @@ public class ChunkProviderClient
             chunk.onUnload();
         }
         chunkMapping.remove(new ChunkCoordinate(i, j));
-        field_889_c.remove(chunk);
+        chunks.remove(chunk);
     }
 
     @Override
@@ -67,8 +70,8 @@ public class ChunkProviderClient
     @Override
     public Chunk provideChunk(int chunkX, int chunkZ)
     {
-        ChunkCoordinate chunkcoordintpair = new ChunkCoordinate(chunkX, chunkZ);
-        Chunk chunk = (Chunk)chunkMapping.get(chunkcoordintpair);
+        ChunkCoordinate coordinate = new ChunkCoordinate(chunkX, chunkZ);
+        Chunk chunk = chunkMapping.get(coordinate);
         if(chunk == null)
         {
             return blankChunk;
@@ -110,7 +113,7 @@ public class ChunkProviderClient
     @Override
     public String getInfoString()
     {
-        return (new StringBuilder()).append("MultiplayerChunkCache: ").append(chunkMapping.size()).toString();
+        return "MultiplayerChunkCache: " + chunkMapping.size();
     }
 
     @Override
@@ -118,8 +121,8 @@ public class ChunkProviderClient
         // Do nothing
     }
 
-    private Chunk blankChunk;
-    private Map chunkMapping;
-    private List field_889_c;
-    private World worldObj;
+    private final Chunk blankChunk;
+    private final Map<ChunkCoordinate, Chunk> chunkMapping;
+    private final List<Chunk> chunks;
+    private final World worldObj;
 }
diff --git a/src/main/java/net/minecraft/client/world/chunk/provider/ChunkProviderStatic.java b/src/main/java/net/minecraft/client/world/chunk/provider/ChunkProviderStatic.java
index 072c481ff..eb7aaa0e8 100644
--- a/src/main/java/net/minecraft/client/world/chunk/provider/ChunkProviderStatic.java
+++ b/src/main/java/net/minecraft/client/world/chunk/provider/ChunkProviderStatic.java
@@ -93,8 +93,8 @@ public class ChunkProviderStatic
         {
             int k = chunkX & 0x1f;
             int l = chunkZ & 0x1f;
-            int i1 = k + l * 32;
-            return chunks[i1] != null && (chunks[i1] == blankChunk || chunks[i1].isAtLocation(chunkX, chunkZ));
+            int chunkIndex = k + l * 32;
+            return chunks[chunkIndex] == blankChunk || (chunks[chunkIndex] != null && chunks[chunkIndex].isAtLocation(chunkX, chunkZ));
         }
     }
 
diff --git a/src/main/java/net/minecraft/core/block/BlockButton.java b/src/main/java/net/minecraft/core/block/BlockButton.java
index 79f0052fc..9db91b6d5 100644
--- a/src/main/java/net/minecraft/core/block/BlockButton.java
+++ b/src/main/java/net/minecraft/core/block/BlockButton.java
@@ -4,6 +4,8 @@ import net.minecraft.core.block.material.Material;
 import net.minecraft.core.entity.EntityLiving;
 import net.minecraft.core.entity.player.EntityPlayer;
 import net.minecraft.core.enums.EnumDropCause;
+import net.minecraft.core.item.Item;
+import net.minecraft.core.item.tag.ItemTags;
 import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
@@ -233,7 +235,7 @@ public class BlockButton extends Block
     @Override
     public void onBlockClicked(World world, int x, int y, int z, EntityPlayer player)
     {
-    	if(!player.isSneaking()) {
+    	if(!Item.hasTag(player.getCurrentEquippedItem(), ItemTags.PREVENT_LEFT_CLICK_INTERACTIONS)) {
     		blockActivated(world, x, y, z, player);
     	}
     }
diff --git a/src/main/java/net/minecraft/core/block/BlockDoor.java b/src/main/java/net/minecraft/core/block/BlockDoor.java
index 237b81e50..f2240c32c 100644
--- a/src/main/java/net/minecraft/core/block/BlockDoor.java
+++ b/src/main/java/net/minecraft/core/block/BlockDoor.java
@@ -9,6 +9,7 @@ import net.minecraft.core.entity.player.EntityPlayer;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.item.tag.ItemTags;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.util.phys.Vec3d;
 import net.minecraft.core.world.World;
@@ -106,7 +107,7 @@ public class BlockDoor extends Block
     
     @Override
 	public void onBlockClicked(World world, int x, int y, int z, EntityPlayer player) {
-    	if(!player.isSneaking()) {
+    	if(!Item.hasTag(player.getCurrentEquippedItem(), ItemTags.PREVENT_LEFT_CLICK_INTERACTIONS)) {
     		blockActivated(world, x, y, z, player);
     	}
     }
diff --git a/src/main/java/net/minecraft/core/block/BlockEdible.java b/src/main/java/net/minecraft/core/block/BlockEdible.java
index 6feeac636..dc0930049 100644
--- a/src/main/java/net/minecraft/core/block/BlockEdible.java
+++ b/src/main/java/net/minecraft/core/block/BlockEdible.java
@@ -77,13 +77,7 @@ public abstract class BlockEdible extends Block {
         eatSlice(world, x, y, z, player);
         return true;
     }
-
-    @Override
-    public void onBlockClicked(World world, int x, int y, int z, EntityPlayer player)
-    {
-        eatSlice(world, x, y, z, player);
-    }
-
+    
     @Override
     public boolean canPlaceBlockAt(World world, int x, int y, int z)
     {
